routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\CastController;
use App\Http\Controllers\GenreController;
use App\Http\Controllers\FilmController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\KomentarController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [IndexController::class, 'index']);
Route::get('/register', [AuthController::class, 'register']);
Route::post('/welcome', [AuthController::class, 'welcome']);

Route::middleware(['auth'])->group(function(){

    Route::get('/data-table', [IndexController::class, 'datatable']);

});
// Route::get('/master', function(){

//     return view('layout.master');
// });
// Route::get('/', function () {
//     return view('welcome');
// });


Route::resource('cast', CastController::class);
Route::resource('film', FilmController::class);
Route::resource('genre', GenreController::class);
Route::resource('film', FilmController::class);

Route::middleware(['auth'])->group(function(){
    Route::get('cast/delete/{id}', [CastController::class, 'delete'])->name('delete');
    Route::get('genre/delete/{id}', [GenreController::class, 'delete'])->name('genre.delete');
    Route::get('film/delete/{id}', [FilmController::class, 'delete'])->name('film.delete');
    Route::post('komentar', [KomentarController::class, 'store']);
});

Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Cast.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Cast extends Model
{
    use HasFactory;

    protected $fillable = ['nama', 'umur', 'bio'];
}

app/Http/Controllers/CastController.php
<?php

namespace App\Http\Controllers;

use App\Models\Cast;
use Illuminate\Http\Request;

class CastController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        
        $this->middleware('auth')->except('index', 'show');
    }

    public function index()
    {
        $casts = Cast::all();
        return view('pages.cast.index', compact('casts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.cast.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'nama' => ['required', 'max:45'],
            'umur' => ['required', 'numeric'],
            'bio'  => 'required'
        ]);

        Cast::create([
            'nama' => $request->nama,
            'umur' => $request->umur,
            'bio'  => $request->bio
        ]);

        return redirect('/cast');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $cast = Cast::find($id);
        return view('pages.cast.detail', compact('cast'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $cast = Cast::find($id);
        return view('pages.cast.edit', compact('cast'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'nama' => ['required', 'max:45'],
            'umur' => ['required', 'numeric'],
            'bio'  => 'required'
        ]);

        $cast = Cast::find($id);
        $cast->nama = $request->nama;
        $cast->umur = $request->umur;
        $cast->bio = $request->bio;
        $cast->update();

        return redirect('/cast');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $cast = Cast::find($id);
        $cast->delete();

        return redirect('/cast');

    }

    public function delete($id)
    {
        $cast = Cast::find($id);

        return view('pages.cast.delete', compact('cast'));
    }
}

resources/views/pages/cast/create.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3 class="card-title">Tambah Cast</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <form action="/cast" method="post">
            @csrf
            <div class="form-group">
                <label>Nama</label>
                <input type="text" name="nama" id="nama" class="form-control form-control-sm">
                @error('nama')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                @enderror
            </div>
            <div class="form-group">
                <label>Umur</label>
                <input type="text" name="umur" id="umur" class="form-control form-control-sm">
                @error('umur')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                @enderror
            </div>
            <div class="form-group">
                <label>Bio</label>
                <textarea name="bio" id="bio" cols="30" rows="10" class="form-control form-control-sm"></textarea>
                @error('bio')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                @enderror
            </div>
            <button type="submit" class="btn btn-sm btn-block btn-primary">Simpan</button>
        </form>
    </div>
</div>
    
@endsection

resources/views/pages/cast/delete.blade.php
{{-- !-- Delete Body -->  --}}
<form action="{{ route('cast.destroy', $cast->id) }}" method="post">
    <div class="modal-body">
        @csrf
        @method('DELETE')
        <h5 class="text-center">Anda yakin menghapus {{ $cast->name }} ini?</h5>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">Tidak</button>
        <button type="submit" class="btn btn-sm btn-danger">Ya, Hapus</button>
    </div>
</form>

resources/views/pages/cast/detail.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3>Detail Cast</h3>        
    </div>
    <div class="card-body">
        <div class="row">
            <div class="col-sm-3">Nama</div>
            <div class="col-sm-9">: {{$cast->nama}} </div>
        </div>
        <div class="row">
            <div class="col-sm-3">Umur</div>
            <div class="col-sm-9">: {{$cast->umur}} </div>
        </div>
        <div class="row">
            <div class="col-sm-3">Bio</div>
            <div class="col-sm-9">: {{$cast->bio}} </div>
        </div>
    </div>
</div>
    
@endsection

resources/views/pages/cast/edit.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3 class="card-title">Edit Cast</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <form action="/cast/{{$cast->id}}" method="post">
            @csrf
            @method('PUT')
            <div class="form-group">
                <label>Nama</label>
                <input type="text" name="nama" id="nama" value="{{$cast->nama}}" class="form-control form-control-sm">
                @error('nama')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                @enderror
            </div>
            <div class="form-group">
                <label>Umur</label>
                <input type="text" name="umur" id="umur" value="{{$cast->umur}}" class="form-control form-control-sm">
                @error('umur')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                @enderror
            </div>
            <div class="form-group">
                <label>Bio</label>
                <textarea name="bio" id="bio" cols="30" rows="10" class="form-control form-control-sm">{{$cast->bio}}
                </textarea>
                @error('bio')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                @enderror
            </div>
            <button type="submit" class="btn btn-sm btn-block btn-primary">Simpan</button>
        </form>
    </div>
</div>
    
@endsection

resources/views/pages/cast/index.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3 class="card-title">List Cast</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <div class="row">
        @forelse ($casts as $item)

            <div class="col-sm-4">
                <div class="card" style="width: 18rem;">
                    <div class="card-body">
                      <h5 class="card-title">{{$item->nama}} </h5> (<span>{{ $item->umur}} </span>)<br> <hr>
                      <p class="card-text">{{$item->bio}} </p>
                      <div class="row">
                        @guest
                        <a href="/cast/{{$item->id}}" class="btn btn-sm btn-primary btn-block mx-1"> Detail</a>
                        @endguest
                        @auth
                        <a href="/cast/{{$item->id}}" class="btn btn-sm btn-primary mx-1"> Detail</a>
                        <a href="/cast/{{$item->id}}/edit" class="btn btn-sm btn-warning mx-1"> Edit</a>
                        <a class="btn btn-sm btn-danger" data-toggle="modal" id="buttonDelete" data-target="#deleteModal" data-attr="{{ route('delete', $item->id) }}" title="Delete Cast">
                             Delete
                            {{-- <i class="fas fa-trash text-danger fa-lg"></i> --}}
                        </a>
                        {{-- <form action="/cast/{{$item->id}}" method="post">
                          @csrf
                          @method('DELETE')
                          <button type="submit" class="btn btn-sm btn-danger mx-1">Delete</button>
          
                          </form> --}}
                            
                        @endauth
        
                      </div>
                    </div>
                </div>

            </div>
            
            
            @empty
            Tidak ada list cast
            @endforelse
        </div>
    
    </div>
</div>

<!-- delete modal -->
<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="smallModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-sm" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body" id="deleteBody">
                <div>
                    {{-- MODAL FORM DELETE --}}
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

@push('script')

    <script>
        // display a modal (small modal)
        $(document).on('click', '#buttonDelete', function(event) {
            event.preventDefault();
            let href = $(this).attr('data-attr');
            console.log(href)
            $.ajax({
                url: href, 
                // beforeSend: function() {
                //     $('#loader').show();
                // },
                // return the result
                success: function(result) {
                    $('#deleteModal').modal("show");
                    $('#deleteBody').html(result).show();
                }, 
                // complete: function() {
                //     $('#loader').hide();
                // }, 
                error: function(jqXHR, testStatus, error) {
                    console.log(error);
                    alert("Page " + href + " cannot open. Error:" + error);
                    $('#loader').hide();
                }, 
                timeout: 8000
            })
        });

    </script>
    
@endpush